$threadheadermod = "Thread Header v1.0 beta<br>by BHRA Webmaster";

###############################################################################
# ThreadHeader.pl                                                             #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
# =========================================================================== #
# Mod Name:    Thread Header - version 1.0 beta                               #
# Written by:  BHRA Webmaster                                                 #
###############################################################################

%head_txt=(
	'1',	"Last Modified by",
	'2',	"on",
	'3',	"Edit",
	'4',	"Delete",
	'5',	"Add Header",
	'6',	"Save",
	'7',	"Reset",
	'8',	"Are you sure you want to delete this header?",
	'9',	"Optional header title (maximum 50 characters)",
	'10',	"Header Message (Maximum 1000 characters)",
	'11',	"You may use HTML and UBBC tags here.",
	'12',	"Use the form below to enter additional information relevent to this thread. This information will be displayed at the top of every page of this thread, and don't worry about making a mistake because it can be changed or deleted at any time.<br><br>You can also include a title for your information box, but this is optional - if you leave the title blank, it will not be displayed!"
);

$color{'headborder'} = "$color{'bordercolor'}";		# Border colour of information box
$headborder = "bordercolor";				# Style class name of the information box border
$color{'headtitle'} = "$color{'titlebg'}";		# Background colour of information title area
$headtitle = "titlebg";					# Style class name of information title area
$color{'headerbg'} = "$color{'windowbg'}";		# Background colour of information message area
$headerbg = "windowbg";					# Style class name of information message area
$header_width = "80%";					# Width of information box 

###############################################################################

sub ShowHeader {
	my $threadid = $_[0];
	my ($header_name, $header_id, $header_date, $header_subject, $tmpa, $tmpb);

	if ($threadid && -e "$datadir/$threadid.head") {
		&LoadCensorList;	# Load Censor List
		$message = "";

		fopen(FILE,"$datadir/$threadid.head");
			$header_name = <FILE>;
			$header_id = <FILE>;
			$header_date = <FILE>;
			$header_subject = <FILE>;
			while (<FILE>) { $message .= $_; }
		fclose(FILE);
		chomp $header_name;
		chomp $header_id;
		chomp $header_date;
		chomp $header_subject;

		# Censor and run UBBC interpreter on header message
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$header_subject =~ s~\Q$tmpa\E~$tmpb~gi;
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		$header_date = &timeformat($header_date);

		if($header_subject ne "" || $message ne "") {$yymain .= qq~
<table cellpadding="0" cellspacing="0" border="0" width="$header_width" bgcolor="$color{'headborder'}" class="$headborder" align="center">
  <tr>
    <td>
      <table cellpadding="3" cellspacing="1" border="0" width="100%">~;
			if($header_subject ne "") { $yymain .= qq~
        <tr>
          <td bgcolor="$color{'headtitle'}" class="$headtitle" align="center"><font size="2" color="$color{'titletext'}" class="text1"><b>$header_subject</b></font></td>
        </tr>~;}
			if($message ne "") { $yymain .= qq~
        <tr>
          <td bgcolor="$color{'headerbg'}" class="$headerbg"><font size="2">$message</font></td>
        </tr>~;}
			$yymain .= qq~
      </table>
    </td>
  </tr>
</table>~;
		}
		if(exists $moderators{$username} || $settings[7] eq "Administrator" || $settings[7] eq "Global Moderator") { $yymain .= qq~
<table width="$header_width" align="center">
  <tr>
    <td align="left"><font size="1">$head_txt{'1'} <a href="$scripturl?action=viewprofile;username=$header_id">$header_name</a> $head_txt{'2'} $header_date</font></td>
    <td align="right"><font size="1"><a href="$cgi;action=addheader;thread=$threadid">$head_txt{'3'}</a> - <a href="$cgi;action=delheader;thread=$threadid" onclick="return confirm('$head_txt{'8'}')">$head_txt{'4'}</a></font></td>
  </tr>
</table><br>~;} else {$yymain .= qq~<br>~;}
	}
}

###############################################################################

sub AddHeader {
	if(!exists $moderators{$username} && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") { &fatal_error("$txt{'1'}");}
	my $threadid = $INFO{'thread'};

	fopen(FILE,"$datadir/$threadid.head");
		$header_name = <FILE>;
		$header_id = <FILE>;
		$header_date = <FILE>;
		$header_subject = <FILE>;
		while (<FILE>) { $message .= $_; }
	fclose(FILE);
	&ToHTML($message);
	$message =~ s~\r~~gi;

	$yymain .= qq~
<form action="$cgi;action=addheader2;thread=$threadid" method="POST">
<table cellpadding="0" cellspacing="0" border="0" width="70%" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
      <table cellpadding="3" cellspacing="1" border="0" width="100%">
        <tr>
          <td class="titlebg" bgcolor="$color{'titlebg'}"><img src="$imagesdir/admin_header.gif" alt="" border="0" align="absmiddle"> <font class="text1" color="$color{'titletext'}" size="2"><b>$head_txt{'5'}</b></font></td>
        </tr><tr>
          <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="1">$head_txt{'12'}</font></td>
        </tr><tr>
          <td bgcolor="$color{'windowbg'}" class="windowbg" align="center">
            <font size="2"><br><input type="text" name="header_subject" size="70" maxlenght="50" value="$header_subject" style="width:60%"><br><b>$head_txt{'9'}</b></font><br><br>
            <font size="2"><br><textarea cols="70" rows="7" name="header_message" style="width:90%">$message</textarea><br><b>$head_txt{'10'}</b></font><font size="1"><br>$head_txt{'11'}</font><br><br>
          </td>
        </tr><tr>
          <td class="catbg" bgcolor="$color{'catbg'}" align="center"><input type="submit" value="$head_txt{'6'}"> &nbsp; <input type="reset" value="$head_txt{'7'}"></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</form>~;

	$yytitle = $head_txt{'5'};
	&template;
	exit;
}

###############################################################################

sub AddHeader2 {
	if(!exists $moderators{$username} && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") { &fatal_error("$txt{'1'}");}
	my $threadid = $INFO{'thread'};

	$header_subject = $FORM{'header_subject'};
	&ToHTML($header_subject);
	$header_message = $FORM{'header_message'};
	if (length($header_subject) > 50) { $subject = substr($header_subject,0,50); }
	if (length($header_message) > 1000) { $subject = substr($header_message,0,1000); }

	fopen(FILE,">$datadir/$threadid.head");
		print FILE qq~$settings[1]\n~;
		print FILE qq~$username\n~;
		print FILE qq~$date\n~;
		print FILE qq~$header_subject\n~;
		print FILE $header_message;
	fclose(FILE);

	$yySetLocation = qq~$cgi;action=display;num=$threadid~;
	&redirectexit;
}

###############################################################################

sub DeleteHeader {
	if(!exists $moderators{$username} && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") { &fatal_error("$txt{'1'}");}
	my $threadid = $INFO{'thread'};

	unlink("$datadir/$threadid.head");

	$yySetLocation = qq~$cgi;action=display;num=$threadid~;
	&redirectexit;
}

1;
